#include "CustomFiberThread.h"
#include "Scripting.h"
#include "../ScriptHook/Log.h"
#include <fstream>
#include <windows.h>

// Pull in all our scripting functions/types
using namespace Scripting;
f32 forceX,forceY,forceZ,hookX,hookY,hookZ,aimerX,aimerY,aimerZ,x3,y3,z3,X1,Y1,Z1,x,y,z,hed,diff,xx,yy,zz,distp,dd,height,landchecks=0;
f32 w1,w2, camr=0, speed1=0,speed2=0;
Object hook,aimer;
Ped lolped;
Ped ped;
bool enabled = true, up=true;
Vector3 CamVec,min,max,CamV,bonev, v1,v2,vv1,vv2;
Camera cam;
f32 PIX = float(atan(1)*4)/180.0f;
f32 trytimes = 0;
bool gotocar = false, ontop=false, firstdown=true, gotocord=false,onwall=false,cardmg=false,bindx=false, bindcar=false,falling=false,checkland=false;
bool heli = false, startup=true;
Vehicle dacar;
f32 dist = 0;
int netid = 0;
f32 worldbind[1000],carbind[1000];
int wbind =0, cbind=0;
int iveh = 0;
int key = 0;
f32 maxdist=500;
u32 ep = 0;




CustomFiberThread::CustomFiberThread()
{
	SetName("JC2-IV");
}

// Some helper functions

Player CustomFiberThread::GetPlayer()
{
	Player playerIndex = ConvertIntToPlayerIndex(GetPlayerId());
	return playerIndex;
}

Scripting::Ped CustomFiberThread::GetPlayerPed()
{
	Ped ped;
	GetPlayerChar(GetPlayer(), &ped);
	return ped;
}

void CustomFiberThread::GetCameraVector(Camera cam, Vector3 &CameraVector) {
	Vector3 CamRot;
	float Sxy, Sz;
	if (DoesCamExist (cam)) {
		GetCamRot (cam, & CamRot.X, & CamRot.Y, & CamRot.Z);
		Sz = CamRot.X*PIX;
		Sxy = (CamRot.Z + 90.0f)*PIX;
		CameraVector.X = cos (Sxy) * cos (Sz);
		CameraVector.Y = sin (Sxy) * cos (Sz); 
		CameraVector.Z = sin (Sz);
	}
}

// The real script

void CustomFiberThread::RunScript()
{
	// This is a fiber thread, so we use an loop to run the contents of this script.
	// The thread will terminate when we return from this function.sadasdsadsa

	while(IsThreadAlive())
	{
		if(startup){
			startup=false;
			ep=GetCurrentEpisode();
		}

		Player playerIndex = ConvertIntToPlayerIndex(GetPlayerId());
		GetPlayerChar(playerIndex, &ped);

		if(enabled){

			//start search for grapple pos if both keys are pressed
			if(GetKeyState(VK_RBUTTON)<0 && GetKeyState(0x45)<0 && IsPlayerControlOn(playerIndex)) { 
				if(up){
					up=false;
					ClearPlayerHasDamagedAtLeastOnePed(playerIndex);
					if(IsCharInAnyCar(ped)){
						GetCarCharIsUsing(ped, &dacar);
						GetCarCoordinates(dacar, &x,&y,&z);
						WarpCharFromCarToCoord(ped, x, y, z+3);
					}
					eWeapon currentweapon;
					GetCurrentCharWeapon(ped, &currentweapon );
					DetachPed(ped,0);
					Vehicle veh;
					Ped daped;
					for(int i = 0; i<49000; i++){
						veh = u32(i);
						if(DoesVehicleExist(veh)){
							if(HasCarBeenDamagedByWeapon(veh, currentweapon)){
								ClearCarLastWeaponDamage(veh);							//clear the vehicle dmg, so we can find the veh which is shot
							}
						}
						else if(DoesCharExist(daped)){
							if(HasCharBeenDamagedByWeapon(daped, currentweapon)){
								ClearCharLastWeaponDamage(daped);
							}
						}
					}

					RequestAnims("parachute");
					GetGameCam(&cam);
					GetCameraVector(cam, CamVec);
					GetCharCoordinates(ped, &x,&y,&z);
					FirePedWeapon(ped, x+1500*CamVec.X, y+1500*CamVec.Y, z+1500*CamVec.Z);
					Wait(10);
					for(int i = 0; i<49000; i++){
						veh=u32(i);

						if(DoesVehicleExist(veh)){
							PrintStringWithLiteralStringNow("STRING", "ext", 1000, 1);//***bug: does not find cars which youve been in **or only if ints are big, after long playing time?
							if(HasCarBeenDamagedByWeapon(veh, currentweapon)){ //set as car found, but postpone grappling till bind check
								cardmg=true;
								dacar=veh;
								iveh=i;
								bindx=false;
								PrintStringWithLiteralStringNow("STRING", "car dmg hold", 1000, 1);
								i=50000;
								SetTimerA(0);
							}
						}
					}
					if(!gotocar && !cardmg){ //car not hooked, do normal wall hook
						if(HasPlayerDamagedAtLeastOnePed(playerIndex)){
							for(int i = 0; i<49000; i++){
								daped=u32(i);
								if(DoesCharExist(daped)){
									if(HasCharBeenDamagedByWeapon(daped, currentweapon)){ 
										PrintStringWithLiteralStringNow("STRING", "ped shot", 1000, 1);
										GetCharCoordinates(daped, &xx,&yy,&zz);
										x = (x-xx);
										y = (y-yy);
										z = (z-zz);
										ApplyForceToPed(daped, 3, x, y, z, 0, 0, 0, 0, 0, 0, 1 );
										SwitchPedToRagdoll(daped, 500, 200, 0, 1, 1, 0);
										i=50000;
										SetTimerA(0);
									}
								}
							}
						}else{
							f32 d = 1;
							f32 ground;
							GetCharCoordinates(ped, &x,&y,&z);
							GetGroundZFor3DCoord(x+d*CamVec.X, y+d*CamVec.Y, z+d*CamVec.Z+1000,&ground);
							while(ground<z+d*CamVec.Z && d<maxdist){ //Check if ground coordinates are higher than aim path, which indicates an obstacle
								d+=0.1f;
								GetGroundZFor3DCoord(x+d*CamVec.X, y+d*CamVec.Y, z+d*CamVec.Z+1000,&ground);
							}
							if(d < maxdist){
								d-=0.5f;
								X1=x+d*CamVec.X;
								Y1=y+d*CamVec.Y;
								Z1=z+d*CamVec.Z+0.3f;
								d-=0.5f;
								GetGroundZFor3DCoord(x+d*CamVec.X, y+d*CamVec.Y, z+d*CamVec.Z+1000,&diff);
								GetDistanceBetweenCoords3D(x+d*CamVec.X,y+d*CamVec.Y,diff,X1,Y1,ground, &diff); //check if its a steep thing, or a wall
								GetDistanceBetweenCoords3D(x,y,z,X1,Y1,Z1, &dist);
								TaskPlayAnimWithFlags(ped, "free_fall_deccelerate", "parachute", 100/dist, u32(dist*14), 1);
								gotocord=true;
								PrintStringWithLiteralStringNow("STRING", "go world", 1000, 1);
							}
						}
					}

				}
				else if(cardmg){
					GetCameraVector(cam, CamV);
					if(TimerA()>100){
						f32 vv = 0.03f; //check if cam moved
						if(CamV.X < CamVec.X-vv || CamV.X > CamVec.X+vv || CamV.Y < CamVec.Y-vv || CamV.Y > CamVec.Y+vv || CamV.Z < CamVec.Z-vv || CamV.Z > CamVec.Z+vv){
							bindx=true;
							PrintStringWithLiteralStringNow("STRING", "lim ex", 1000, 1);
						}
					}
				}

			}//click
			else{
				up=true;

				if(cardmg){
					cardmg=false;
					if(bindx){
						PrintStringWithLiteralStringNow("STRING", "bind car", 1000, 1);
						//BIND FUCKING CARS TO CAR OR MOFICKUN WORLD!

						eWeapon currentweapon;
						GetCurrentCharWeapon(ped, &currentweapon );
						Vehicle veh;
						bindcar=false;
						for(int i = 0; i<49000; i++){
							veh = u32(i);
							if(DoesVehicleExist(veh)){
								if(HasCarBeenDamagedByWeapon(veh, currentweapon)){
									ClearCarLastWeaponDamage(veh);
								}
							}
						}
						GetCameraVector(cam, CamVec);
						GetCharCoordinates(ped, &x,&y,&z);
						FirePedWeapon(ped, x+1000*CamVec.X, y+1000*CamVec.Y, z+1000*CamVec.Z);
						Wait(10);
						for(int i = 0; i<49000; i++){
							veh=u32(i);
							if(DoesVehicleExist(veh)){
								PrintStringWithLiteralStringNow("STRING", "extbind2", 1000, 1);
								if(HasCarBeenDamagedByWeapon(veh, currentweapon)){
									//bind car to car
									PrintStringWithLiteralStringNow("STRING", "car dmg bind", 1000, 1);
									i=60000;
									bindcar=true;

									GetCarCoordinates(iveh, &x,&y,&z);
									GetCarCoordinates(veh, &xx,&yy,&zz);
									GetDistanceBetweenCoords3D(x,y,z,xx,yy,zz, &diff);

									carbind[cbind]=float(iveh); cbind++; //car1
									carbind[cbind]=float(veh); cbind++; //car2
									carbind[cbind]=diff; cbind++; //rope length

									eModel dModel;
									GetCarModel(iveh, &dModel);
									GetModelDimensions(dModel, &min, &max);
									carbind[cbind]=sqrtf(max.X*max.X+max.Y*max.Y+max.Z*max.Z); cbind++; //car1 weight
									GetCarModel(veh, &dModel);
									GetModelDimensions(dModel, &min, &max);
									carbind[cbind]=sqrtf(max.X*max.X+max.Y*max.Y+max.Z*max.Z); cbind++; //car2 weight

									//apply force to each car in others car dirsction, multi by weight and something with velocity dir and sped
								}
							}
						}
						if(!bindcar){ //car not hooked, do normal wall hook
							f32 d = 1;
							f32 ground;
							GetCharCoordinates(ped, &x,&y,&z);
							GetGroundZFor3DCoord(x+d*CamVec.X, y+d*CamVec.Y, z+d*CamVec.Z+1000,&ground);
							while(ground<z+d*CamVec.Z && d<500){
								d+=0.1f;
								GetGroundZFor3DCoord(x+d*CamVec.X, y+d*CamVec.Y, z+d*CamVec.Z+1000,&ground);
							}
							if(d < 500){
								//bind to cord
								PrintStringWithLiteralStringNow("STRING", "world bind", 1000, 1);
								GetCarCoordinates(dacar, &x,&y,&z);
								GetDistanceBetweenCoords3D(x+d*CamVec.X,y+d*CamVec.Y,z+d*CamVec.Z,x,y,z, &diff);
								worldbind[wbind]=float(iveh); wbind++;
								worldbind[wbind]=x+d*CamVec.X; wbind++;
								worldbind[wbind]=y+d*CamVec.Y; wbind++;
								worldbind[wbind]=z+d*CamVec.Z; wbind++;
								worldbind[wbind]=diff; wbind++;

							}
						}



					}else{
						gotocar=true;
						//normal grapple to car
						eModel dModel;
						GetCarModel(dacar, &dModel);
						GetModelDimensions(dModel, &min, &max);
						//	FreezeCharPositionAndDontLoadCollision(ped, 0);
						GetCarCoordinates(dacar, &x,&y,&z);
						z+=max.Z+0.6f;
						GetCharCoordinates(ped, &X1,&Y1,&Z1);
						GetDistanceBetweenCoords3D(x,y,z,X1,Y1,Z1, &dist);
						TaskPlayAnimWithFlags(ped, "free_fall_deccelerate", "parachute", 100/dist, u32(dist*10), 1);
					}
				}



				if(GetKeyState(0x45)<0 && IsPlayerControlOn(playerIndex)) { //stunt jump on top of car
					if(IsCharInAnyCar(ped)){//***add check if talking
						GetCarCharIsUsing(ped,&dacar);
						GetCarCoordinates(dacar, &x,&y,&z);
						eModel dModel;
						GetCarModel(dacar, &dModel);
						GetModelDimensions(dModel, &min, &max);
						WarpCharFromCarToCoord(ped, x, y, z+3);
						AttachPedToCar(ped, dacar, 0, 0, 0, max.Z + 0.8f, 0, 0, 0, 0 );
						ontop=true;
						GetCarSpeed(dacar, &speed2);
						char buffer[1024];
						sprintf_s(buffer,"%.0f",float(dacar));
						PrintStringWithLiteralStringNow("STRING", buffer, 2000, 1);
					}
				}
			} //released one of butts
		}//enabled

		if(gotocord){ //applyforce towards coordinate, and get stuck when near
			if(IsPedRagdoll(ped)){SwitchPedToAnimated(ped, 1); TaskPlayAnimWithFlags(ped, "free_fall_deccelerate", "parachute", 1, 5000, 1);}
			GetCharCoordinates(ped, &x,&y,&z);
			GetDistanceBetweenCoords3D(x,y,z,X1,Y1,Z1, &dist);
			if(dist<2){
				gotocord=false;
				SetCharCoordinates(ped, X1, Y1, Z1);
				SwitchPedToAnimated(ped, 1);
				if(diff>2){
					FreezeCharPosition(ped, 1);
					onwall=true;
				}else{
					TaskPlayAnimWithFlags(ped, "land_safe", "parachute", 8.5f, -1, 1);
				}
			}else{
				if(GetKeyState(VK_SPACE)<0) { 
					gotocord=false;
					GetCharHeightAboveGround(ped, &height);
					if(height>30 && dist>40 && ep==2){
						GiveWeaponToChar(ped, WEAPON_PARACHUTE, 2, 0);
						SetCurrentCharWeapon(ped, WEAPON_PARACHUTE, 1);
						mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
						Wait(0);
						mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
						GetCharVelocity(ped, &xx, &yy, &zz);
						int tt= 0;
						while(zz>-5 && tt<1000){
							ApplyForceToPed(ped, 3, 0, 0, -2, 0, 0, 0, 0, 0, 0, 1 );
							Wait(0);
							tt++;
							GetCharVelocity(ped, &xx, &yy, &zz);
							if(tt==1000)PrintStringWithLiteralStringNow("STRING","MAX", 2000, 1);
						}
					}
					else if(height<3){
						checkland=true;
						landchecks=0;
					}else{
						SwitchPedToRagdoll(ped, 500, 200, 0, 1, 1, 0);
					}
					//

				}
				x = ( X1 - x)/2;
				y = ( Y1 - y)/2;
				z = ( Z1 - z)/2;
				ApplyForceToPed(ped, 3, x, y, z, 0, 0, 0, 0, 0, 0, 1 );
			}
		}

		if(checkland && landchecks<1000){
			//if(IsPedRagdoll(ped)){SwitchPedToAnimated(ped, 1); TaskPlayAnimWithFlags(ped, "free_fall_deccelerate", "parachute", 10, 5000, 1);}
			GetCharHeightAboveGround(ped, &height);
			landchecks++;
			if(height<1){
				checkland=false;
				TaskPlayAnimWithFlags(ped, "land_fast", "parachute", 5.5f, -1, 1);
			}
		}


		if(onwall){
			Vector3 CamRot;
			GetGameCam(&cam);
			if (DoesCamExist (cam)) {
				GetCamRot (cam, & CamRot.X, & CamRot.Y, & CamRot.Z);
				SetCharHeading(ped, CamRot.Z);
			}
			if(GetKeyState(VK_SPACE)<0 || GetKeyState(0x45)<0) { 
				if(IsPlayerControlOn(playerIndex)){
					FreezeCharPosition(ped, 0);
					onwall=false;
				}
			}

		}
		if(DoesCharExist(ped) && ep==2){

			if(!gotocord && !gotocar && !onwall && !ontop && IsPedRagdoll(ped)){

				GetCharHeightAboveGround(ped, &height);
				if(height>20){
					//ApplyForceToPed(ped, 3, 0, 0, -1, 0, 0, 0, 0, 0, 0, 1);
					GetCharVelocity(ped, &x, &y, &z);
					if(z<0){
						//SwitchPedToAnimated(ped, 1);
						GetHeadingFromVector2D(x, y, &hed);
						SetCharHeading(ped, hed);

						GiveWeaponToChar(ped, WEAPON_PARACHUTE, 2, 0);
						SetCurrentCharWeapon(ped, WEAPON_PARACHUTE, 1);
						mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
						Wait(0);
						mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
					}

				}
			}
		}

		if(gotocar){
			if(DoesVehicleExist(dacar)){
				if(IsPedRagdoll(ped)){SwitchPedToAnimated(ped, 1); TaskPlayAnimWithFlags(ped, "free_fall_deccelerate", "parachute", 0.1f, 5000, 1);}
				GetCarCoordinates(dacar, &x,&y,&z);
				eModel dModel;
				GetCarModel(dacar, &dModel);
				if(!IsThisModelAHeli(dModel)){
					z+=max.Z+0.8f;
				}else{
					z-=max.Z/2;
				}
				GetCharCoordinates(ped, &X1,&Y1,&Z1);
				GetDistanceBetweenCoords3D(x,y,z,X1,Y1,Z1, &dist);
				if(dist<3){ //add long time check
					gotocar=false;
					if(IsThisModelAHeli(dModel)){ //model is heli, hold on under heli.
						AttachPedToCar(ped, dacar, 0, -0.5f, 0, -max.Z/2+0.75f, 0, 0, 0, 1);
						UnlockRagdoll(ped,1);
						SwitchPedToRagdoll(ped,30000,0,1,1,1,0);
						Wait(1);
						if(IsPedRagdoll(ped)) 
						{
							GetPedBonePosition(ped,Left_Hand,0,0,0,&bonev);
							AttachPedToCarPhysically(ped,dacar,Left_Hand,0,bonev.X,bonev.Y,bonev.Z,-1,0,1);
							CreateNmMessage(1,28);
							SetNmMessageFloat(31,15.0f);
							SetNmMessageFloat(32,0.55f);
							SendNmMessage(ped);
							CreateNmMessage(1,3);
							SendNmMessage(ped);
							GetOffsetFromCarInWorldCoords(dacar,(float)0,1.0f,3.0f,&hookX,&hookY,&hookZ);
							CreateNmMessage(1,237);
							SetNmMessageVec3(243,hookX,hookY,hookZ);
							SendNmMessage(ped);
						}
					}
					else {
					SwitchPedToRagdoll(ped,30000,0,1,1,1,0);
					Wait(2);
					SwitchPedToAnimated(ped, 1);
					AttachPedToCar(ped, dacar, 0, 0, 0, max.Z + 0.8f, 0, 0, 0, 0 );
					}
					ontop=true;
					GetCarSpeed(dacar, &speed2);
				}else{

					if(GetKeyState(VK_SPACE)<0) { 
						gotocar=false;
						SwitchPedToRagdoll(ped, 500, 200, 0, 1, 1, 0);

					}
					x = ( x - X1 )/2;
					y = ( y - Y1 )/2;
					z = ( z - Z1 )/2;
					ApplyForceToPed(ped, 3, x, y, z, 0, 0, 0, 0, 0, 0, 1 );
				}
			}else{
				gotocar=false;
			}
		}

		if(ontop){
			if(DoesVehicleExist(dacar)){

				eModel dModel;
				GetCarModel(dacar, &dModel);
				if(IsThisModelAHeli(dModel))heli=true;
				else heli=false;

				if(GetKeyState(0x45)<0 && GetKeyState(VK_RBUTTON)<0 && IsPlayerControlOn(playerIndex)){
					DetachPed(ped,0);
					ontop=false;
				}
				else if(GetKeyState(VK_SPACE)<0 && IsPlayerControlOn(playerIndex)) { 
					DetachPed(ped,0);
					ontop=false;
				}
				else if(GetKeyState(0x46)<0 && IsPlayerControlOn(playerIndex)) { 
					ontop=false;
					if(DoesVehicleExist(dacar)){
						GetDriverOfCar(dacar, &lolped);
						if(DoesCharExist(lolped)){
							SetPedForceFlyThroughWindScreen(lolped);
							Wait(300);
							GetDriverOfCar(dacar, &lolped);
							if(DoesCharExist(lolped)){
							GetCharInCarPassengerSeat(dacar, 0, &lolped);
							if(DoesCharExist(lolped)){
								DetachPed(ped, 0);
								WarpCharIntoCarAsPassenger(ped, dacar, 0);
							}else{
								DetachPed(ped, 0);
							}
							}else{
								DetachPed(ped, 0);
							WarpCharIntoCar(ped, dacar);
							}
						}else{
							DetachPed(ped, 0);
							WarpCharIntoCar(ped, dacar);
						}
					}

				}
				else if(ontop && GetKeyState(VK_RBUTTON)<0 ) { 
					if(0){//firstdown){
						Wait(500);
						firstdown=false;
					}
					Vector3 CamRot;
					GetGameCam(&cam);
					if (DoesCamExist (cam)) {
						GetCamRot (cam, & CamRot.X, & CamRot.Y, & CamRot.Z);
						GetCarHeading(dacar, &hed);
						
						if(!heli){
							AttachPedToCar(ped, dacar, 0, 0, 0, max.Z + 0.8f, CamRot.Z-hed, 0, 0, 0 );

						}else{
							//AttachPedToCar(ped, dacar, 0, 0, 0, -max.Z/2, CamRot.Z-hed, 0, 0, 0 );
						}
						
					}else{firstdown=true;}
				}

				if(!heli){
					f32 roll,pitch;
					GetCarRoll(dacar, &roll);
					GetCarPitch(dacar, &pitch);
					GetCarSpeedVector(dacar, &vv1,0);
					GetCarSpeed(dacar, &speed1);
					if(pitch>45 || pitch<-45 || roll>45 || roll<-45 || vv1.Z<-10){
						ontop=false; 
						DetachPed(ped,0);
						SwitchPedToRagdoll(ped, 500, 200, 0, 1, 1, 0);
					}else if(speed1<speed2-5){
						ontop=false; 
						DetachPed(ped,0);
						SwitchPedToAnimated(ped,1);
						Wait(1);
						GetCarSpeedVector(dacar, &vv2,0);
						ApplyForceToPed(ped, 3, vv2.X*100, vv2.Y*100, vv2.Z*100, 0, 0, 0, 0, 0, 0, 1 );
						SwitchPedToRagdoll(ped, 500, 200, 0, 1, 1, 0);
					}
					speed2=speed1;
					
				}else{
					GetCharHeightAboveGround(ped, &height);
					if(height<2){
						DetachPed(ped,0);
						ontop=false;
					}
				}

			}
			else{ontop=false; DetachPed(ped,0);}
		}

		//world bind physics loopsy
		if(wbind>0){
			for(int i =0; i<wbind; i+=5){
				Vehicle Veh = u32(worldbind[i]);
				if(DoesVehicleExist(Veh)){
					//Vector3 vs;
					GetNetworkIDFromVehicle(Veh, &netid);
					RequestControlOfNetworkId(netid);
					xx=worldbind[i+1];
					yy=worldbind[i+2];
					zz=worldbind[i+3];
					dd=worldbind[i+4];
					GetCarCoordinates(Veh, &x,&y,&z);
					GetDistanceBetweenCoords3D(x,y,z,xx,yy,zz, &distp);
					/*f32 a = asin((y-yy)/distp);
					xx=xx+cos(a)*dd;
					yy=yy+sin(a)*dd;
					a = asin((z-zz)/distp);
					zz=zz+sin(a)*dd;*/
					if(distp>dd-2){
						//GetCarSpeedVector(Veh, &vs, 0);
						forceX=((xx+((x-xx)/distp)*(dd-2))-x)/2;
						forceY=((yy+((y-yy)/distp)*(dd-2))-y)/2;
						forceZ=((zz+((z-zz)/distp)*(dd-2))-z)/2;
						ApplyForceToCar(Veh, 3, forceX, forceY, forceZ, 0, 0, 0, 0, 0, 0, 1);
					}
				}
			}
		}

		//car bind physics loop
		if(cbind>0){
			for(int i =0; i<cbind; i+=5){
				Vehicle Veh = u32(carbind[i]);
				Vehicle Vehx = u32(carbind[i+1]);
				if(DoesVehicleExist(Veh) && DoesVehicleExist(Vehx)){
					GetNetworkIDFromVehicle(Veh, &netid);
					RequestControlOfNetworkId(netid);
					GetNetworkIDFromVehicle(Vehx, &netid);
					RequestControlOfNetworkId(netid);
					dd=carbind[i+2];
					w1=carbind[i+3];
					w2=carbind[i+4];
					GetCarCoordinates(Veh, &x,&y,&z);
					GetCarCoordinates(Vehx, &xx,&yy,&zz);
					GetDistanceBetweenCoords3D(x,y,z,xx,yy,zz, &distp);
					if(distp>dd){
						//GetCarSpeedVector(Veh, &v1, 0);
						//GetCarSpeedVector(Vehx, &v2, 0);

						//apply to veh, using veh2 vect, 
						forceX=((xx-x)/(distp))*(distp-dd)*(w2/w1);
						forceY=((yy-y)/(distp))*(distp-dd)*(w2/w1);
						forceZ=((zz-z)/(distp))*(distp-dd)*(w2/w1);
						ApplyForceToCar(Veh, 3, forceX, forceY, forceZ, 0, 0, 0, 0, 0, 0, 1);

						forceX=((x-xx)/(distp))*(distp-dd)*(w1/w2);
						forceY=((y-yy)/(distp))*(distp-dd)*(w1/w2);
						forceZ=((z-zz)/(distp))*(distp-dd)*(w1/w2);
						ApplyForceToCar(Vehx, 3, forceX, forceY, forceZ, 0, 0, 0, 0, 0, 0, 1);
					}
				}
			}
		}


		Wait(0);

	}


}


/*
char buffer[1024];
sprintf_s(buffer,"%.3f",vs.Y);
PrintStringWithLiteralStringNow("STRING", buffer, 2000, 1);



Xdist = (gmain.x - obj.x);
Ydist = (gmain.y - obj.y);
dist = Math.sqrt(Xdist* Xdist + Ydist* Ydist)-min*2;
if(dist<10){dist=10;}
rad = Math.atan2(Ydist, Xdist);
jj[o]= new Point((dist/constx)*Math.cos(rad), (dist/constx)*Math.sin(rad)+1);
return jj[o];
*/